
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Tool_providersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const tool_providers = await db.tool_providers.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        kind: data.kind
        ||
        null
            ,
            
        base_url: data.base_url
        ||
        null
            ,
            
        supports_oauth: data.supports_oauth
        ||
        false
        
            ,
            
        supports_webhook: data.supports_webhook
        ||
        false
        
            ,
            
        docs_url: data.docs_url
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await tool_providers.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return tool_providers;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const tool_providersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                kind: item.kind
            ||
            null
            ,
            
                base_url: item.base_url
            ||
            null
            ,
            
                supports_oauth: item.supports_oauth
            ||
            false
        
            ,
            
                supports_webhook: item.supports_webhook
            ||
            false
        
            ,
            
                docs_url: item.docs_url
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const tool_providers = await db.tool_providers.bulkCreate(tool_providersData, { transaction });

        // For each item created, replace relation files
        

        return tool_providers;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const tool_providers = await db.tool_providers.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.kind !== undefined) updatePayload.kind = data.kind;
        
        
        if (data.base_url !== undefined) updatePayload.base_url = data.base_url;
        
        
        if (data.supports_oauth !== undefined) updatePayload.supports_oauth = data.supports_oauth;
        
        
        if (data.supports_webhook !== undefined) updatePayload.supports_webhook = data.supports_webhook;
        
        
        if (data.docs_url !== undefined) updatePayload.docs_url = data.docs_url;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await tool_providers.update(updatePayload, {transaction});

        
        
        if (data.organizations !== undefined) {
            await tool_providers.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return tool_providers;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const tool_providers = await db.tool_providers.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of tool_providers) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of tool_providers) {
                await record.destroy({transaction});
            }
        });


        return tool_providers;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const tool_providers = await db.tool_providers.findByPk(id, options);

        await tool_providers.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await tool_providers.destroy({
            transaction
        });

        return tool_providers;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const tool_providers = await db.tool_providers.findOne(
            { where },
            { transaction },
        );

        if (!tool_providers) {
            return tool_providers;
        }

        const output = tool_providers.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        output.tools_provider = await tool_providers.getTools_provider({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organizations = await tool_providers.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tool_providers',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.base_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tool_providers',
                        'base_url',
                        filter.base_url,
                    ),
                };
            }
            
            if (filter.docs_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tool_providers',
                        'docs_url',
                        filter.docs_url,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.kind) {
                where = {
                    ...where,
                kind: filter.kind,
            };
            }
            
            if (filter.supports_oauth) {
                where = {
                    ...where,
                supports_oauth: filter.supports_oauth,
            };
            }
            
            if (filter.supports_webhook) {
                where = {
                    ...where,
                supports_webhook: filter.supports_webhook,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.tool_providers.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'tool_providers',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.tool_providers.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

